#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct dete
{
	char ime[30];
	int uzrast;
	int bri;
	int balans;
	struct dete *levi,*desni;
}dete;

#define novi(x) x=(dete*)malloc(sizeof(dete));



int dubina(dete *p)
{
	int dd=0,dl=0;
	
	if(p)
	{
		if (p->levi) dl=dubina(p->levi);
		if(p->desni) dd=dubina(p->desni);
		if (dd>dl) return dd++;
		else return dl++;
	}
	else return 0;
}

void lrotacija(dete **p)
{
	dete *poml,*pomd;
	
	poml=*p;
	pomd=poml->desni;
	poml->desni=pomd->levi;
	pomd->levi=poml;
	*p=pomd;
	
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}

void drotacija(dete **p)
{
	dete *poml,*pomd;
	
	pomd=*p;
	poml=pomd->levi;
	pomd->levi=poml->desni;
	poml->desni=pomd;
	*p=poml;
	
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}

int dodaj(dete **p,char ime[],int uz,int bri)
{
	dete *t=*p;
	int rez,ink;
	
	if(!t)
	{
		novi(t);
		strcpy(t->ime,ime);
		t->uzrast=uz;
		t->bri=bri;
		t->desni=t->levi=NULL;
		t->balans=0;
		rez=1;
	}
	else
	{
		int c,c2;
		c2=ime[0];
		c=t->ime[0];
		
		if (uz!=t->uzrast)
		{
		if(uz>t->uzrast) ink=dodaj(&(t->desni),ime,uz,bri);
		else ink=-dodaj(&(t->levi),ime,uz,bri);
		}
		else if(strcmp(ime,t->ime)!=0)
		{	
			if(c>c2) ink=dodaj(&(t->desni),ime,uz,bri);
			else ink=-dodaj(&(t->levi),ime,uz,bri);
		}
		else
		{
			ink=dodaj(&(t->desni),ime,uz,bri);
		}
		t->balans+=ink;
		
		if(ink!=0 && t->balans!=0)
		{
			if(t->balans<-1)
			{
				if(t->levi->balans<0) drotacija(&t);
				else
				{
					lrotacija(&(t->levi));
					drotacija(&t);
				}
			}
			else if(t->balans>1)
			{
				if(t->desni->balans>0) lrotacija(&t);
				else
				{
					drotacija(&(t->desni));
					lrotacija(&t);
				}
			}
			else rez=1;
		}
	}
	*p=t;
	return rez;
	
}


dete *form(char fajl[])
{
	dete *p=NULL;
	char ime[30];
	int uz,bri;
	int i,n;
	FILE *f;
	f=fopen(fajl,"r");
	
	fscanf(f,"%d",&n);
	
	for (i=0;i<n;i++)
	{
		fscanf(f,"%s",ime);
		fscanf(f,"%d",&uz);
		fscanf(f,"%d",&bri);
		dodaj(&p,ime,uz,bri);
	}
	return p;
}

void ispis(dete *p)
{
	if(p)
	{
		ispis(p->desni);
		printf("%s\t%d\t%d\n",p->ime,p->uzrast,p->bri);
		ispis(p->levi);
	}
}

void brisi(dete *p,dete **y,int x)
{
	if(p)
	{
		if(p->desni) brisi(p->desni,y,x);
		if (((p->uzrast)+12)<=x)
		dodaj(y,p->ime,p->uzrast,p->bri);
		if(p->levi) brisi(p->levi,y,x);
	}
}
/*
void dodaj2(dete *p,dete **y,int k,int br)
{
	dete *poml,*pomd,*pom;
	pom=pomd=poml=p;
	while (pom)
	{
		printf("udje\n");
		if(pomd->desni)
		{ 
			pomd=pomd->desni;
			br++;
			pom=pomd;
		}
		else if(pomd->levi)
		{
			pomd=pomd->levi;
			br++;
			pom=pomd;
		}
		else if(poml->levi)
		{ 
			poml=poml->levi;
			br++;
			pom=poml;
		}
		else if (poml->desni)
		{
			poml=poml->desni;
			br++;
			pom=poml;
		}
		printf("%d\n",br);
		if((br+2)==k)
		{
			//printf("nasao %s\n",p->ime);
			poml=pom->levi;
			pomd=pom->desni;
			pom2=poml->levi;
			dodaj(y,pom2->ime,pom2->uzrast,pom2->bri);
			pom=poml->desni;
			dodaj(y,pom2->ime,pom2->uzrast,pom2->bri);
			pom=pomd->levi;
			dodaj(y,pom2->ime,pom2->uzrast,pom2->bri);
			pom2=pomd->desni;
			dodaj(y,pom2->ime,pom2->uzrast,pom2->bri);
			p=NULL;
			
		}
	}
}*/

main(int argc,char *argv[])
{
	dete *p;
	p=form(argv[1]);
	ispis(p);
	printf("unesi x\n");
	
	int x;
	scanf("%d",&x);
	dete *y=NULL;
	x*=12;
	brisi(p,&y,x);
	printf("posle brisanja bi trebalo ovako da izgleda\n");
	
	ispis(y);
	
	dete *z=NULL;
	int br=0;
	int k;
	
/*	printf("uneti nivo koji se trazi\n");
	scanf("%d",&k);
	dodaj2(p,&z,k,br);
	
	ispis(z);*/
}
