#include<stdio.h>
#include<stdlib.h>
#include<string.h>

struct Dete
{
	char	*Ime;
	int	Godine;
	int	Igracke;
	int	Balans;
	struct	Dete *levi,*desni;
};

int	Dubina(struct Dete *p)
{	
	int	dl,dd;
	dl=dd=0;
	if(p)
	{
		if(p->levi) dl=Dubina(p->levi);
		if(p->desni) dd=Dubina(p->desni);
		if(dl>dd) return ++dl;
		else	return	++dd;
	}
	else	return	0;
}

void	lrotacija(struct Dete **p)
{
	struct	Dete	*poml,*pom1;
	pom1=*p;
	poml=pom1->desni;
	
	pom1->desni=poml->levi;
	poml->levi=pom1;
	
	*p=poml;
	
	poml->Balans=Dubina(poml->desni)-Dubina(poml->levi);
	pom1->Balans=Dubina(pom1->desni)-Dubina(pom1->levi);
}

void	drotacija(struct Dete **p)
{
	struct	Dete	*pomd,*pom1;
	pom1=*p;
	pomd=pom1->levi;
	
	pom1->levi=pomd->desni;
	pomd->desni=pom1;
	
	*p=pomd;
	
	pomd->Balans=Dubina(pomd->desni)-Dubina(pomd->levi);
	pom1->Balans=Dubina(pom1->desni)-Dubina(pom1->levi);
}		
	


int	Dodaj(struct Dete **p,char Niz[],int g,int pak)
{
	struct	Dete	*t;
	int	Inkrement,Rezultat;
	Rezultat=0;
	t=*p;

	if(t==NULL)
	{
		t=(struct Dete*) malloc(sizeof(struct Dete));
		if(t==NULL)
		{
			printf("Grska pri alokaciji!\n");
			exit(0);	
		}
		t->levi=t->desni=NULL;
		t->Balans=0;
		t->Ime=(char*) malloc(strlen(Niz)+1);
		strcpy(t->Ime,Niz);

		t->Godine=g;
		t->Igracke=pak;
		Rezultat=1;
	}
	else
	{
		if((strcmp(t->Ime,Niz)==0) && (g==t->Godine))	Inkrement=Dodaj(&(t->desni),Niz,g,pak);
		else	if(t->Godine==g)
			{
				if(strcmp(Niz,t->Ime)<=1) Inkrement=Dodaj(&(t->desni),Niz,g,pak);
				else	if((strcmp(Niz,t->Ime)>=-1)) Inkrement=-Dodaj(&(t->levi),Niz,g,pak);
			}
			else	if(t->Godine<g) Inkrement=Dodaj(&(t->desni),Niz,g,pak);
				else	Inkrement=-Dodaj(&(t->levi),Niz,g,pak);
		
		t->Balans+=Inkrement;

		if(Inkrement!=0 && t->Balans!=0)
		{
			if(t->Balans<-1)
			{
				if(t->levi->Balans<0) drotacija(&t);
				else
				{
					lrotacija(&(t->levi));
					drotacija(&t);
				}
			}
			else	if(t->Balans>1)
			{
				if(t->desni->Balans>0)	lrotacija(&t);
				else	
				{
					drotacija(&(t->desni));
					lrotacija(&t);
				}
			} else	Rezultat=1;
		}
	}
	*p=t;
	return	Rezultat;
}

struct	Dete *form()
{
	struct	Dete	*p;
	p=NULL;
	int	k,o,i,n;
	char	Ime[100];

	printf("Unesite koliko ima dece:  ");
	scanf("%d",&n);
	getchar();
	
	for(i=0;i<n;i++)
	{
		printf("Unesite ime deteta:  ");
		gets(Ime);
		printf("Unesite uzrast:  ");
		scanf("%d",&k);
		printf("Unesite broj poklona:  ");
		scanf("%d",&o);
		getchar();
		Dodaj(&p,Ime,k,o);
	}

	return	p;
}

void	Ispis(struct Dete *p)
{
	if(p)
	{
		if(p->desni) Ispis(p->desni);
		printf("Ime: %s,Starost(meseci): %d,Paketi: %d\n",p->Ime,p->Godine,p->Igracke);
		if(p->levi) Ispis(p->levi);
	}
}

void	Izbaci(struct	Dete *p,struct Dete **q,int x)
{
	if(p)
	{
		if((p->Godine+12/12)>x) Dodaj(q,p->Ime,p->Godine,p->Igracke);
		if(p->levi) Izbaci(p->levi,q,x);
		if(p->desni) Izbaci(p->desni,q,x);
	}
}

/*void	Treca(struct Dete *p,int k,int m)
{
	if(p);
	{
		if((Dubina(p)==k) && (p->Igracke)==m);
			printf("Ime:  %s,Uzrast:  %d",p->Ime,p->Godine);
		if(p->levi) Treca(p->levi,k,m);
		if(p->desni) Treca(p->desni,k,m);
	}
}
*/
main()
{
	struct	Dete	*p,*q;
	q=NULL;
	p=form();
	int	x,k,m;
	Ispis(p);
	printf("\nUnesite x:  ");
	scanf("%d",&x);
	Izbaci(p,&q,x);
	Ispis(q);
	printf("Unesite k pa m:  ");
	//scanf("%d",&k);
	//scanf("%d",&m);
	//Treca(q,k,m);
}
