#include <stdio.h>
#include <string.h>
#include <stdlib.h>

typedef struct oo
{
	char *ime;
	int god;
	int broj;
	int balans;
	struct oo *levi;
	struct oo *desni;
} deca;

#define novi(x) x=(deca*)malloc(sizeof(deca))
#define novis(x,z) x=(char*)malloc(strlen(z)+1)

void Ispis(deca *p)
{
	if(p)
	{
		if(p->desni) Ispis(p->desni);
		printf("%s %d %d \n",p->ime,p->god,p->broj);
		if(p->levi) Ispis(p->levi);
	}
}

int Dubina(deca *p)
{
	int dd, dl;
	dd=dl=0;
	if(p)
	{
		if(p->desni) Dubina(p->desni);
		if(p->levi) Dubina(p->levi);
		if(dd>dl) return ++dd;
		else return ++dl;
	}
}

void desnarotacija(deca **p)
{
	deca *poml,*pomd;
	pomd=*p;
	poml=(*p)->levi;
	pomd->levi=poml->desni;
	poml->desni=pomd;
	*p=poml;
	poml->balans=Dubina(poml->desni)-Dubina(poml->levi);
	pomd->balans=Dubina(pomd->desni)-Dubina(pomd->levi);
}

void levarotacija(deca **p)
{
	deca *poml,*pomd;
	poml=*p;
	pomd=(*p)->desni;
	poml->desni=pomd->levi;
	pomd->levi=poml;
	*p=pomd;
	poml->balans=Dubina(poml->desni)-Dubina(poml->levi);
	pomd->balans=Dubina(pomd->desni)-Dubina(pomd->levi);
}

int Dodaj(deca **p, char *ime, int god, int broj)
{
	deca *t = *p;
	int ink, rez;
	ink=rez=0;
	if(t==NULL)
	{
		novi(t);
		novis(t->ime,ime);
		strcpy(t->ime,ime);
		t->god=god;
		t->broj=broj;
		t->balans=0;
		t->levi=t->desni=NULL;
		rez=1;
	}
	else {
		if(t->broj > broj) ink = -Dodaj(&(t->levi),ime,god,broj);
		else if (t->broj < broj) ink = Dodaj(&(t->desni),ime,god,broj);
		else if(strcmp(t->ime,ime)>0) ink = -Dodaj(&(t->levi),ime,god,broj);
		else ink=Dodaj(&(t->desni),ime,god,broj);
		
		t->balans+=ink;
		
		if(t->balans!=0 && ink!=0)
		{
			if(t->balans < -1)
			{
				if(t->levi->balans < 0) desnarotacija(&t);
				else {
					levarotacija(&(t->levi));
					desnarotacija(&t);
				}
			}
			else if(t->balans > 1)
			{
				if(t->desni->balans > 0) levarotacija(&t);
				else {
					desnarotacija(&(t->desni));
					levarotacija(&t);
				}
			}
			else rez=1;
		}
	}
	*p=t;
	return rez;
}

deca *Form(deca *p, FILE *f)
{
	int n,i,god,broj;
	char ime[50];
	fscanf(f,"%d",&n);
	for(i=0;i<n;i++)
	{
		fscanf(f,"%s",ime);
		fscanf(f,"%d",&god);
		fscanf(f,"%d",&broj);
		Dodaj(&p,ime,god,broj);
	}
	fclose(f);
	return p;
}

void nova(deca *p, deca **q, int x)
{
	if(p)
	{
		if(((p->god+12)/12) < x ) Dodaj(q,p->ime,p->god,p->broj);
		if(p->desni) nova(p->desni,q,x);
		if(p->levi) nova(p->levi,q,x);
	}
}

void ispisime(deca *q,int k, int m,int db)
{
	if(q){
	if(db==k && q->broj==m) printf("%s %d %d \n",q->ime,q->god,q->broj);
	ispisime(q->levi,k,m,db+1);
	ispisime(q->desni,k,m,db+1);
	}
}

int main(int argc, char *argv[])
{
	FILE *f=fopen(argv[1],"r");
	deca *p=NULL, *q=NULL;
	int x,k,m,db=0;
	p=Form(p,f);
	Ispis(p);
	scanf("%d",&x);
	nova(p,&q,x);
	Ispis(q);
	scanf("%d",&k);
	scanf("%d",&m);
	ispisime(q,k,m,db);
	return 0;
}
