#include<stdio.h>
#include<string.h>
#include<stdlib.h>

typedef struct dete
{
	char ime[50];
	int uzrast;
	int broj_igracaka;
	int bal;
	struct dete *levi,*desni;
} DETE;

int Dubina(DETE *p)
{
	int dl;
	int dd;
	
	if(p)
	{
	if(p->levi) dl=Dubina(p->levi);
	if(p->desni) dd=Dubina(p->desni);
	if(dl>dd) return ++dl;
	else return ++dd;
	}
	else return 0;
}

DETE *lrotacija(DETE *p)
{
DETE *pom;
pom=p->desni->levi;
p->desni->levi=p;
p=p->desni;

p->levi->bal=Dubina(p->levi->desni)-Dubina(p->levi->levi);
p->bal=Dubina(p->desni)-Dubina(p->levi);
return p;
}

DETE *drotacija(DETE *p)
{
DETE *pom;
pom=p->levi->desni;
p->levi->desni=p;
p=p->levi;

p->desni->bal=Dubina(p->desni->desni)-Dubina(p->desni->levi);
p->bal=Dubina(p->desni)-Dubina(p->levi);
return p;
}

int Dodaj(DETE **p2,DETE *temp)
{
DETE *p;
int rezultat,ink;

rezultat=0;
p=(*p2);

if(p==NULL)
	{
		p=temp;
		p->levi=NULL;
		p->desni=NULL;
		rezultat=1;
		p->bal=0;
	}	
else
	{
		if((temp->uzrast>p->uzrast) || ( (temp->uzrast=p->uzrast) && ((strcmp(temp->ime,p->ime)>=1)) ))
		ink=Dodaj(&(p->desni),temp);
		else
		ink=-Dodaj(&(p->levi),temp);
		
		p->bal+=ink;
		
		if((p->bal!=0) && (ink!=0))
		{
			if(p->bal<-1)
				{
					if(p->levi->bal<0)
						{
							p=drotacija(p);
						}
						else
						{
							p->levi=lrotacija(p->levi);
							p=drotacija(p);
						}
				}
			if(p->bal>1)
				{
					if(p->desni->bal>0)
						{
							p=lrotacija(p);
						}
						else
						{
							p->desni=drotacija(p->desni);
							p=lrotacija(p);
						}
				}
				else rezultat=1;
		}
	}
		
(*p2)=p;
return rezultat;

}

void Kreiraj(DETE **p2)
{
	DETE *temp,*p;
	p=(*p2);
	int i,n;
	char ime[50];
	int uzrast;
	int broj_igracaka;
	
	printf("Unesi broj N: \n");
	scanf("%d",&n);
	getchar();
	
	for(i=0;i<n;i++)
	{
		temp=malloc(sizeof(DETE));
		
		gets(temp->ime);
		scanf("%d",&temp->uzrast);
		scanf("%d",&temp->broj_igracaka);
		getchar();
		
		Dodaj(&p,temp);
	}
		
	(*p2)=p;	
}

void Ispis(DETE *p)
{
	if(p)
	{
		Ispis(p->desni);
		printf("%s \t %d \t %d \n",p->ime,p->uzrast,p->broj_igracaka);
		Ispis(p->levi);
	}
}

DETE *Brisanje(DETE *p,DETE *NOVO,int godine)
{
	if(p)
	{
		NOVO=Brisanje(p->levi,NOVO,godine);
		NOVO=Brisanje(p->desni,NOVO,godine);
		p->levi=NULL;
		p->desni=NULL;
		if((p->uzrast)<(godine*12))
		Dodaj(&NOVO,p);		
	}
	return NOVO;
}
main()
{
	DETE *p=NULL;
	int x;
	Kreiraj(&p);
	printf("PRE BRISANJA:\n");
	Ispis(p);	
	printf("Unesi X: \n");
	scanf("%d",&x);
	p=Brisanje(p,NULL,x);
	printf("POSLE BRISANJA:\n");
	Ispis(p);
}



































