#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct _Cvor{
	char *ime;
	int uzrast;
	int broj_igracaka;
	int balans;
	struct _Cvor *levi,*desni;
}cvor;


int dubina(cvor *p){
	int dd=0,dl=0;
	if(p){
		if(p->levi) dl=dubina(p->levi);
		if(p->desni) dd=dubina(p->desni);
		if(dd>dl) return dd++;
		else return dl++;
	}
	else return 0;
}

void lrotacija(cvor **p){
	cvor *poml,*pomd;
	poml=(*p);
	pomd=poml->desni;
	poml->desni=pomd->levi;
	pomd->levi=poml;
	(*p)=pomd;
	
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
	
}

void drotacija(cvor **p){
	cvor *poml,*pomd;
	pomd=(*p);
	poml=pomd->levi;
	pomd->levi=poml->desni;
	poml->desni=pomd;
	(*p)=poml;
	
	pomd->balans=dubina(pomd->levi)-dubina(pomd->desni);
	poml->balans=dubina(poml->levi)-dubina(poml->desni);
	
}



void unos(cvor **p){
	cvor *pom,*temp;
	pom=(*p);
	char s[20];
	int n,i,k,broj;
	printf("Unesi broj dece\n");
	scanf("%d",&n);
	getchar();
	for(i=0;i<n;i++){
		
		temp=(cvor*)malloc(sizeof(cvor));
		temp->levi=temp->desni=NULL;
		gets(s);
		temp->ime=(char *)malloc(sizeof(char)*strlen(s)+1);
		strcpy(temp->ime,s);
		printf("Unesi uzrast deteta\n");
		scanf("%d",&k);
		temp->uzrast=k;
		printf("unesi broj igracaka\n");
		scanf("%d",&broj);
		temp->broj_igracaka=broj;
		getchar();
		dodaj(&pom,temp);
	}
	
	(*p)=pom;
}

int dodaj(cvor **p, cvor *temp){
	int rez=1,inkrement=0;
	cvor *pom;
	char s[20],b[20];
	pom=(*p);
	
	if(pom==NULL){
		pom=temp;
		pom->balans=0;
		rez=1;
	}else{
		if((pom->uzrast > temp->uzrast) && (strcmp(pom->ime,temp->ime)>0)
		 {
			if(strcmp(pom->ime,temp->ime)>0) 
			inkrement=-dodaj(&(pom->levi),temp);
			else inkrement=dodaj(&(pom->desni),temp);
		 }
		//else inkrement=dodaj(&(pom->desni),temp);
		
		pom->balans=pom->balans+inkrement;
		
		if(pom->balans!=0 && inkrement!=0){
			if(pom->balans<-1){
				if(pom->levi->balans<0) drotacija(&pom);
				else {
					lrotacija(pom->levi);
					drotacija(&pom);
				}
			}else if(pom->balans>1){
				if(pom->desni->balans>0) lrotacija(&pom);
				else{
					drotacija(&(pom->desni));
					lrotacija(pom->levi);
				}
				else rez=1;
			}
		}
	}
	(*p)=pom;
	return rez;
}

void ispis(cvor *p){
	cvor *pom=p;
	if(p){
		if(p->desni) ispis(p->desni);
		printf("%s %d %d\n",pom->ime,pom->uzrast,pom->broj_igracaka);
		if(p->levi)  ispis(p->levi);
	}
}

/*void brisi(cvor *p, cvor **q, int k, int m){
	cvor *
}*/

void nadji(cvor *p, int k, int m){
	if(p){
		//while(k>1){
			if(p->desni) nadji(p->desni,k-1,m);
			if(p->levi) nadji(p->levi,k-1,m);
			/*if(p->desni==NULL && p->levi==NULL)
			{
				 printf("nema dovoljno slova\n"); 
				 return;
			}*/
	//}
	//if((k==1) && (p->broj_igracaka==m)) printf("%s %d\n",p->ime,p->uzrast);
	} //else printf("prazno\n");
	if((k==1) && (p->broj_igracaka==m)) printf("%s %d\n",p->ime,p->uzrast);
	
  }


main(){
	cvor *p=NULL;
	int k,m;
	unos(&p);
	ispis(p);
	printf("unesi zeljeni nivo\n");
	scanf("%d",&k);
	printf("unesi m\n");
	scanf("%d",&m);
	nadji(p,k,m);
	
	//brisi(p,&q,s);
}
