#include<stdio.h>
#include<stdlib.h>
#include<string.h>

#define novi(x) x=(drvo *)malloc(sizeof(drvo));

typedef struct drvo{
	char ime[20];
	int uzrast;
	int igracke;
	int balans;
	struct drvo *levi, *desni;
}drvo;

void ispis(drvo *p){
	if(p){
		if(p->desni) ispis(p->desni);
		printf("%s\t%d\t%d\n", p->ime, p->uzrast, p->igracke);
		if(p->levi) ispis(p->levi);
	}
}

int dubina(drvo *p){
	int dd=0, dl=0;
	if(p){
		if(p->desni) dd=dubina(p->desni);
		if(p->levi) dl=dubina(p->levi);
		if(dd>dl) return dd++;
		else return dl++;
	}
	else return 0;
}

void lrot(drvo **p){
	drvo *poml, *pomd;
	poml=*p;
	pomd=poml->desni;
	poml->desni=pomd->levi;
	pomd->levi=poml;
	*p=pomd;
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}

void drot(drvo **p){
	drvo *poml, *pomd;
	pomd=*p;
	poml=pomd->levi;
	pomd->levi=poml->desni;
	poml->desni=pomd;
	*p=poml;
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}

int dodaj(drvo **p, char ime[], int uzrast,int igracke){
	drvo *pom;
	pom=(*p);
	int ink;
	int rez=0;
	if(pom==NULL){
		novi(pom);
		strcpy(pom->ime, ime);
		pom->uzrast=uzrast;
		pom->igracke=igracke;
		pom->balans=0;
		pom->levi=pom->desni=NULL;
		rez=1;
	}
	else{
		if((uzrast>pom->uzrast) || (strcmp(ime, pom->ime)==1) ||
		((uzrast==pom->uzrast) && (strcmp(ime, pom->ime)==0)))
		ink=dodaj(&(pom->desni), ime, uzrast, igracke);
		else ink=-dodaj(&(pom->levi), ime, uzrast, igracke);
		pom->balans=pom->balans+ink;
		if(ink!=0 && pom->balans!=0){
			if(pom->balans<-1){
				if(pom->levi->balans<0) drot(&pom);
				else{
					lrot(&(pom->levi));
					drot(&pom);
				}
			}
			else if(pom->balans>1){
				if(pom->desni->balans>0) lrot(&pom);
				else{
					drot(&(pom->desni));
					lrot(&pom);
				}
			}
			else rez=1;
		}
	}
	*p=pom;
	return rez;
}
		
		
			
drvo *form(drvo *p, int n){
	p=NULL;
	char ime[20];
	int uzrast, igracke;
	int i;
	for(i=0;i<n;i++){
		scanf("%s",ime);
		scanf("%d", &uzrast);
		scanf("%d", &igracke);
		dodaj(&p, ime, uzrast, igracke);
	}
	return p;
}

void brisi(drvo *p, drvo **q, int x){
	*q=NULL;
	if(p){
		if((p->uzrast/12)<=x){
			dodaj(q, p->ime, p->uzrast, p->igracke);
			brisi(p->levi, q, x);
			brisi(p->desni, q, x);
		}
		else
		{
			brisi(p->levi, q, x);
			brisi(p->desni, q, x);
		}
	}
	else return;
}

main(){
	drvo *p;
	drvo *q;
	int n;
	scanf("%d", &n);
	p=form(p, n);
	ispis(p);
	printf("\n");
	int x;
	scanf("%d", &x);
	brisi(p, &q, x);
	ispis(q);
}
