#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct cvor
{	
	char ime[30];
	int uzrast;
	int br_igracaka;
	int balans;
	struct cvor *levi, *desni;
}

int dubina(struct cvor *p)
{	
	int dl=0,dd=0;
	if (p)
	{	
		if(p->levi) dl=dubina(p->levi);
		if(p->desni) dd=dubina(p->desni);
		if (dl>dd) return ++dl;
		else return ++dd;
	}
	else return(0);
}

void lrotacija(struct cvor **t)
{
	struct cvor *poml, *pomd;
	
	poml=*t;
	pomd=poml->desni;
	poml->desni=pomd->levi;
	pomd->levi=poml;
	
	*t=pomd;

poml->balans=dubina(poml->desni)-dubina(poml->levi);
pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);

}


void drotacija(struct cvor **t)
{
	struct cvor *poml, *pomd;
	
	pomd=*t;
	poml=pomd->levi;
	pomd->levi=poml->desni;
	poml->desni=pomd;
	
	*t=poml;

poml->balans=dubina(poml->desni)-dubina(poml->levi);
pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);

}

void ispis(struct cvor *t)
{	
	if(t!=NULL)
	{	ispis(t->levi);
		printf("%s %d %d",t->ime,t->uzrast,t->br_igracaka);
		ispis(t->desni);
	}
}

int funkcija(int n, int x)
{	
	if (n/12 > x*12) return (1);
	else if (((n/12)==(x*12)) && (n%12!=0)) return (1);
	else return(0);
} 	






struct cvor *brisi(struct cvor *p, struct cvor **t)
{
	if(p)
	{ brisi(p->levi,t);
	  if(funkcija(p->uzrast,x)!=1)
	  dodaj(t,p->ime,p->uzrast,p->br_igracaka);	
 	  brisi(p->desni,t)
	}
}

int dodaj( struct cvor **t, char ime[30], int uzrast, int broj_ig)
{
	struct cvor *p=*t;
	int inkrement, rezultat=0;
	
	if (t==NULL)
	{
		t=(struct cvor*)malloc(sizeof(struct cvor));
	  if(t==NULL)
	  {
		printf("Greska pri alokaciji memorije.\n");
		exit(0);
	  }

	strcpy(t->ime, ime);
	t->uzrast=uzrast;
	t->br_igracaka=broj_ig;
	t->balans=0;
	rezultat=1;
	
	else
	{ if(uzrast>t->uzrast) inkrement=dodaj(&(t->desni),t->ime,t->uzrast,t->br_igracaka);
	  else inkrement= -dodaj(&(t->levi),t->ime,t->uzrast,t->br_igracaka);
	 
	t->balans+=inkrement;
	
	  if(t->balans<-1) {  if (t->balans->levi<0) lrotacija(&t);
				else { drotacija(&(t->desni));
				       lrotacija(&t);
				     }
			   }
	  if(t->balans>1)  { if (t->balans->desni>0) drotacija(&t);
				else { lrotacija(&(t->levi));
					drotacija(&t); }
			   }
	  else rezultat=0;
	}
	return rezultat;
	
}

main()

{	int i,n;
	char ime[30];
	int uzrast;
	int br_igracaka;
	struct cvor *s=NULL;
	scanf("%d", &n);

	for(i=0; i<n; i++)
	{
		getchar();
		gets(ime);
		scanf("%d", uzrast);
		scanf("%d", br_igracaka);
		dodaj(&s,s->ime, s->uzrast, s->br_igracaka);
		
	}
	
	ispis(s);
}	















	























































	






	








	





