#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct dete
{
    char *ime;
    int uzrast, igracke;

    int balans;
    struct dete *levi, *desni;
};

int dodaj(struct dete **, char *, int, int);
struct dete *form(char *);
void l_rotacija(struct dete **);
void d_rotacija(struct dete **);
int dubina(struct dete *);
void pisi(struct dete *);
void novo_stablo(struct dete *, struct dete **, int );
void pisi_2 (struct dete *, int , int , int );


int main(int argc, char *argv[])
{
    struct dete *p,*q = NULL;
    p = form(argv[1]);
    printf("ime \t meseci broj igracaka\n");
    pisi(p);

    printf("\n unesite x:");
    int x;
    scanf("%d",&x);
    x= x*12;
    novo_stablo(p,&q,x);
    printf("ime \t meseci broj igracaka\n");
    pisi(q);

    printf("\n\nunesite K i M: ");
    int K,M;
    scanf("%d%d",&K, &M);
    pisi_2(q,1,K,M);

    //printf("Hello World!\n");
    return 0;
}

struct dete *form (char *dat)
{
    struct dete *koren;
    koren = NULL;
    char ime[20];
    FILE *f =fopen(dat,"r");
    int n, uzrast, igracke;
    fscanf(f,"%d",&n);
    while(n)
    {
        fscanf(f,"%s%d%d",ime, &uzrast, &igracke);
        dodaj(&koren,ime,uzrast,igracke);
        n--;
    }
    return koren;

}

void l_rotacija(struct dete **t)
{
    struct dete *poml, *pomd;
    poml=*t;
    pomd=poml->desni;
    poml->desni = pomd->levi;
    pomd->levi = poml;
    *t =pomd;

    poml->balans = dubina(poml->desni) - dubina(poml->levi);
    pomd->balans = dubina(pomd->desni) - dubina(pomd->levi);

}

void d_rotacija(struct dete **t)
{
    struct dete *poml,*pomd;
    pomd=*t;
    poml=pomd->levi;
    pomd->levi = poml->desni;
    poml->desni = pomd;
    *t = poml;


    poml->balans = dubina(poml->desni) - dubina(poml->levi);
    pomd->balans = dubina(pomd->desni) - dubina(pomd->levi);
}

int dubina(struct dete *p)
{
    if(p==NULL) return 0;
    int a = 1 + dubina(p->levi);
    int b = 1 + dubina(p->desni);
    if(a>b) return a;
    else return b;
}

void pisi(struct dete *p)
{
    if(p==NULL) return;
    pisi(p->desni);
    printf("%s\t %4d \t %4d \n",p->ime,p->uzrast,p->igracke);
    pisi(p->levi);
}


int dodaj(struct dete **p, char *ime, int uzrast, int igracke)
{
    struct dete *t;
    int inkrement, rezultat = 0;
    t = *p;
    if(t==NULL)
    {
        t = (struct dete *)malloc(sizeof(struct dete));
        if(t==NULL)
        {
            printf("Greska pri alokaciji memorije\n");
            exit(0);
        }
        t->ime = (char *)malloc(sizeof(char));
        strcpy(t->ime, ime);
        t->uzrast = uzrast;
        t->igracke = igracke;
        t->balans = 0;
        t->levi = t->desni = NULL;
        rezultat = 1;
    }
    else
    {
        if(t->uzrast == uzrast)
        {
            if(strcmp(ime,t->ime) >=0 )
                inkrement = dodaj(&(t->desni),ime, uzrast, igracke);
            else
                inkrement = -dodaj(&(t->levi),ime, uzrast, igracke);
        }
        else
            if(t->uzrast < uzrast)
                inkrement = dodaj(&(t->desni),ime, uzrast, igracke);
            else
                inkrement = -dodaj(&(t->levi),ime, uzrast, igracke);

        t->balans +=inkrement;
        if(inkrement !=0 && t->balans!=0)
        {
            if(t->balans <-1)
            {
                if(t->levi->balans <0) d_rotacija(&t);
                else
                {
                    l_rotacija(&(t->levi));
                    d_rotacija(&t);
                }
            }
            else
                if(t->balans > 1)
                {
                    if(t->desni->balans > 0) l_rotacija(&t);
                    else
                    {
                        d_rotacija(&(t->desni));
                        l_rotacija(&t);
                    }
                }
                else rezultat = 1;
        }
    }

    *p = t;
    return rezultat;
}



void novo_stablo(struct dete *p, struct dete **q, int x)
{
    if(p==NULL) return;

    if(p->uzrast < x)
    {
        dodaj(q,p->ime,p->uzrast,p->igracke);
        novo_stablo(p->desni,q,x);
    }
    novo_stablo(p->levi,q,x);

}


void pisi_2 (struct dete *p, int i, int K, int M)
{
    if(p==NULL || i>K) return;

    pisi_2(p->desni,i+1, K,M);
    if(i == K && p->igracke == M)
        printf("nivo:%d \t %s\t %4d %4d \n", i,p->ime,p->uzrast,p->igracke);
    pisi_2(p->levi, i+1,K,M);
}

































