#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct dete {
	char ime[20];
	int uzrast;
	int broj_igracaka;
	struct dete *levi,*desni;
	int bal;
}DETE;

int dubina(DETE *p)
{
	int dd,dl;
	dd=0;
	dl=0;
	
	if(p!=NULL)
	{
		if(p->levi) dl=dubina(p->levi);
		if(p->desni) dd=dubina(p->desni);
		if(dd>dl) return ++dd;
		else
			return ++dl;
		}
	else return 0;
}

DETE *lrotacija(DETE *p)
{
	DETE *pom;
	pom=p->desni->levi;
	p->desni->levi=p;
	p=p->desni;
	p->levi->desni=pom;
	
	p->levi->bal=dubina(p->desni->levi)-dubina(p->levi->levi);
	p->bal=dubina(p->desni)-dubina(p->levi);
	return p;
	
}

DETE *drotacija(DETE *p)
{
	DETE *pom;
	pom=p->levi->desni;
	p->levi->desni=p;
	p=p->levi;
	p->desni->levi=pom;
	
	p->desni->bal=dubina(p->desni->desni)-dubina(p->desni->levi);
	p->bal=dubina(p->desni)-dubina(p->levi);
	return p;
}

int dodaj(DETE **p2,DETE *temp) 
{
	DETE *p;
	int ink,rezultat=0;
	p=(*p2);
	
	if(p==NULL)
	{
		p=temp;
		p->levi=NULL;
		p->desni=NULL;
		p->bal=0;
		rezultat=1;
	}
	else {
		/*1 ako je levi veci
		-1 desni veci */
		if((temp->uzrast>p->uzrast) || (temp->uzrast==p->uzrast && strcmp(temp->ime,p->ime)==1))
		 ink=dodaj(&(p->desni),temp);
		else
		 ink=-dodaj(&(p->levi),temp);
	  p->bal+=ink;
	  
	  
	  if(ink != 0 && p->bal != 0)
	  {
		  if(p->bal<-1)
		  {
			  if(p->levi->bal<0)
			  {
				  p=drotacija(p);
			  }
			  else
			  {
				  p->levi=lrotacija(p->levi);
				  p=drotacija(p);
			  }
		  }
		  else if (p->bal>1)
		  {
			  if(p->desni->bal>0)
			  {
				  p=lrotacija(p);
			  }
			  else
			  {
				  p->desni=drotacija(p);
				  p=lrotacija(p);
			  }
			  
		  }
		  else rezultat=1;
	  }
	  
	}
	(*p2)=p;
	return rezultat;
}

void kreiraj(DETE **p2,int n)
{
	DETE *p,*temp;
	p=(*p2);
	int i;
	char ime[20];
	int uzrast;
	int broj_igracaka;
	getchar();
	
	for(i=0;i<n;i++)
	{
		temp=malloc(sizeof(DETE));
		gets(ime);
		strcpy(temp->ime,ime);
		scanf("%d",&uzrast);
		temp->uzrast=uzrast;
		scanf("%d",&broj_igracaka);
		temp->broj_igracaka=broj_igracaka;
		dodaj(&p,temp);
		getchar();
	}
	(*p2)=p;
}

void ispis(DETE *p)
{
	if(p!=NULL)
	{
		ispis(p->desni);
		printf("%s %d %d %d\n",p->ime,p->uzrast,p->broj_igracaka,p->bal);
		ispis(p->levi);
	}
}

DETE *brisanje(DETE *p,DETE *NOVO,int provera)
{
	if(p!=NULL)
	{
		NOVO=brisanje(p->levi,NOVO,provera);
		NOVO=brisanje(p->desni,NOVO,provera);
		p->levi=NULL;
		p->desni=NULL;
		if(provera<=p->uzrast)
		dodaj(&NOVO,p);
	}
	return NOVO;
}

main()
{
	DETE *p=NULL;
	int n,x,provera;
	printf("unesite n:\n");
	scanf("%d",&n);
	kreiraj(&p,n);
	ispis(p);
	printf("unesite x\n");
	scanf("%d",&x);
	provera=x*12;
	p=brisanje(p,NULL,provera);
	ispis(p);
}


