#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct drvo
{
	int balans;
	int uzrast, broj;
	char ime[50];
	struct drvo *levi, *desni;
};

#define novi(x) x=(struct drvo *)malloc(sizeof(struct drvo))

int dubina (struct drvo *t)
{
	int dd, dl;
	dd=dl=0;
	if (t)
	{
		if (t->levi)
			dl=dubina(t->levi);
		if (t->desni)
			dd=dubina(t->desni);
		if (dd > dl)
			return dd++;
		else
			return dl++;
	}
	else
		return 0;
}

void lrotacija(struct drvo **p)
{
	struct drvo *poml, *pomd;
	poml=*p;
	pomd=poml->desni;
	poml->desni=pomd->levi;
	pomd->levi=poml;
	*p=pomd;
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}

void drotacija(struct drvo **p)
{
	struct drvo *poml, *pomd;
	pomd=*p;
	poml=pomd->levi;
	pomd->levi=poml->desni;
	poml->desni=pomd;
	*p=poml;
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}

int dodaj(struct drvo **p, struct drvo *t)
{
	int rezultat, inkrement, ind;
	struct drvo *pom;
	pom=*p;
	if (pom==NULL)
	{
		pom=t;
		rezultat=1;
	}
	else
	{
		if(t->uzrast > pom->uzrast)
			inkrement=dodaj(&(pom->desni),t);
		else if (t->uzrast < pom->uzrast)
			inkrement=-dodaj(&(pom->levi),t);
		else
		{
			ind=strcmp(t->ime,pom->ime);
			if (ind >= 0)
				inkrement=dodaj(&(pom->desni),t);
			else
				inkrement=-dodaj(&(pom->levi),t);
		}
		pom->balans += inkrement;
		if ((pom->balans) && (inkrement))
		{
			if (pom->balans < -1)
			{
				if (pom->levi->balans < 0)
					drotacija(&pom);
				else
				{
					lrotacija(&(pom->levi));
					drotacija(&pom);
				}
			}
			else if (pom->balans > 1)
			{
				if (pom->desni->balans > 0)
					lrotacija(&pom);
				else
				{
					drotacija(&(pom->levi));
					lrotacija(&pom);
				}
			}
			else
				rezultat=1;
		}
	}
	*p=pom;
	return rezultat;
}

struct drvo * form()
{
	struct drvo *t, *koren;
	int n, i, br, mes;
	char temp[50];
	koren=NULL;
	printf("Unesite broj dece: ");
	scanf("%d",&n);
	for (i=0; i<n; i++)
	{
		novi(t);
		printf("Unesite ime deteta: ");
		getchar();
		gets(temp);
		strcpy(t->ime,temp);
		printf("Unesite uzdrast deteta: ");
		scanf("%d",&t->uzrast);
		printf("Unesite broj poklona koje dete dobija: ");
		scanf("%d",&t->broj);
		t->balans=0;
		t->levi=t->desni=NULL;
		dodaj(&koren,t);
	}
	return koren;
}

void ispis(struct drvo *p)
{
	if (p)
	{
		ispis(p->desni);
		printf("%s, star %d meseci treba da dobije %d poklona.\n",p->ime,p->uzrast,p->broj);
		ispis(p->levi);
	}
}

/*
int nivo (struct drvo *p)
{
	struct drvo pom;
	pom=p;
	int k, m, i, br=0;
	printf("Unesite nivo trazene dece: ");
	scanf("%d",&k);
	printf("Unesite broj poklona: ");
	scanf("%d",&k);
	if((pom) && br=k);
	{
		br=nivo(pom->levi);
		br++;
		printf("%s, star %d meseci",pom->ime,pom->uzrast);
		br=nivo(pom->desni);
	}
}
*/	
		

main()
{
	struct drvo *koren;
	koren=form();
	ispis(koren);
}
