#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct dete{
	char ime[20];
	int starost;
	int bri;
	int balans;
	struct dete *levi,*desni;
	}dete;

#define novi(x)=(dete*)malloc(sizeof(dete));

int dubina(dete *p){
	int dd=0,dl=0;
	if(p){
		if(p->levi) dl=dubina(p->levi);
		if (p->desni) dd=dubina(p->desni);
		if(dd>dl) return dd++;
		else return dl++;
		}
	else return 0;
	}

void lrotacija(dete **p){
	dete *poml,*pomd;
	poml=*p;
	pomd=poml->desni;
	poml->desni=pomd->levi;
	pomd->levi=poml;
	*p=pomd;
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}

void drotacija(dete **p){
	dete *poml,*pomd;
	pomd=*p;
	poml=pomd->levi;
	pomd->levi=poml->desni;
	poml->desni=pomd;
	*p=poml;
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}

int dodaj(dete **p,char ime[],int starost,int bri){
	dete *t=*p;
	int ink,rez;
	if(t==NULL){
		novi(t);
		strcpy(t->ime,ime);
		t->starost=starost;
		t->bri=bri;
		t->levi=t->desni=NULL;
		t->balans=0;
		rez=1;
		}
	else{
		if(starost > t->starost)
			if(ime < t->ime) 
				ink=dodaj(&(p->desni),ime,starost,bri);
				else ink=dodaj(&(p->levi),starost,bri);
		else ink=dodaj(&(p->levi),ime,starost,bri);
		t->balans+=ink;
		if(ink!=0 && t->balans!=0)
			{
				if(t->balans<-1)
				{
					if(t->levi->balans<0) drotacija(&t);
				else {
					lrotacija(&(t->levi));
					drotacija(&t);
					}
				}
			else if (t->balans > 1)
				 {
					 if(t->desni->balans > 0) lrotacija(&t);
				     else {
					drotacija(&(t->desni));
					lrotacija(&t);
					}
					}
		else rez=1;		
		}
		}
	*p=t;
	return rez;
	}
	
dete *form(){
	dete *p=NULL;
	FILE f;
	int i,n,star,bri;
	char ime[20];
	f=fopen("deda.txt","r");
	fscanf(f,"%d",&n);
	fgetc(f);
	for(i=0;i<n;i++){
		fgets(ime,20,f);
		strtok(ime,"\n");
		fscanf(f,"%d",&star);
		fscanf(f,"%d",&bri);
		dodaj(&p,ime,star,bri);
		}
	return p;
	}

dete *brisi(dete *p,dete **y,int x){
	if(p){
		brisi(p->levi,y,x);
		if (p->starost<x)
		dodaj(y,p->ime,p->starost,p->bri);
		brisi(p->desni,y,x);
		}
	}
	
void ispis(dete *p){
	if(p){
	ispis(p->desni);
	printf("%s\t%d  %d",p->ime,p->starost,p->bri);
	ispis(p->levi);
	}
}

main(){
	dete *p,*y;
	int x;
	form();
	isips(*p);
	printf("Unesi starosnu granicu\n");
	scanf("%d",&x);
	brisi(p,y,x);
	ispis(y);
	}
