#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<math.h>

struct dete
{
	char ime[20];
	int uzrast;
	int igracaka;
	int balans;
	struct dete *levi;
	struct dete *desni;
};

struct dete *formiraj(FILE *f)
{
	struct dete *vrh;
	vrh=NULL;
	int n,uzrast,igracaka;
	char linija[80],linija2[80];
	fgets(linija,80,f);
	sscanf(linija,"%d",&n);
	while(n>0)
	{
		fgets(linija,80,f);
		linija[strlen(linija)-1]='\0';
		fgets(linija2,80,f);
		sscanf(linija2,"%d",&uzrast);
		fgets(linija2,80,f);
		sscanf(linija2,"%d",&igracaka);
		dodaj(&vrh,linija,uzrast,igracaka);
		n--;
	}
	return vrh;
}

void drotacija(struct dete **p)
{
	struct dete *poma,*pomb;
	poma=*p;
	pomb=poma->levi;
	poma->levi=pomb->desni;
	pomb->desni=poma;
	*p=pomb;
	pomb->balans=dubina(pomb->desni)-dubina(pomb->levi);
	poma->balans=dubina(poma->desni)-dubina(poma->levi);
}

void lrotacija(struct dete **p)
{
	struct dete *poma,*pomb;
	poma=*p;
	pomb=poma->desni;
	poma->desni=pomb->levi;
	pomb->levi=poma;
	*p=pomb;
	pomb->balans=dubina(pomb->desni)-dubina(pomb->levi);
	poma->balans=dubina(poma->desni)-dubina(poma->levi);
}

int dodaj(struct dete **p,char *ime,int uzrast,int igracaka)
{
	int rezultat,inkrement;
	rezultat=0;
	struct dete* t=*p;
	if(t==NULL)
	{
		t=(struct dete*)malloc(sizeof(struct dete));
		if(t==NULL)
		{
			printf("Greska pri alokaciji memorije!");
			exit(0);
		}
		strcpy(t->ime,ime);
		t->uzrast=uzrast;
		t->igracaka=igracaka;
		t->balans=0;
		t->levi=NULL;
		t->desni=NULL;
		rezultat=1;
	}
	else
	{
		if((uzrast==t->uzrast) && (strcmp(ime,t->ime)==0) || (uzrast==t->uzrast) && (strcmp(ime,t->ime)>0) || (uzrast>t->uzrast)) 
		inkrement=dodaj(&(t->desni),ime,uzrast,igracaka);
		else inkrement=-dodaj(&(t->levi),ime,uzrast,igracaka);
		t->balans +=inkrement;
		if(inkrement!=0 && t->balans!=0)
		{
			if(t->balans<-1)
			{
				if(t->levi->balans<0) drotacija(&t);
				else { lrotacija(&(t->levi)); drotacija(&t); }
			}
			else if(t->balans>1)
			{
				if(t->desni->balans>0) lrotacija(&t);
				else { drotacija(&(t->desni)); lrotacija(&t); }
			}
			else rezultat=1;
		}
	}
	*p=t;
	return rezultat;
}

int dubina(struct dete *vrh)
{
	int dd,ld;
	if(vrh)
	{
		dd=dubina(vrh->desni);
		ld=dubina(vrh->levi);
		if(dd>ld) return dd++;
		else return ld++;
	}
}

void ispis(struct dete *vrh)
{
	if(vrh==NULL) return;
	ispis(vrh->desni);
	printf("%s %4d %4d\n",vrh->ime,vrh->uzrast,vrh->igracaka);
	ispis(vrh->levi);
}

main(int argc,char* argv[])
{
	FILE *f;
	f=fopen(argv[1],"r");
	struct dete *vrh;
	vrh=NULL;
	vrh=formiraj(f);
	ispis(vrh);
	fclose(f);
}
