#include<stdio.h>
#include<stdlib.h>
#include<string.h>

struct dete
{
	char ime[10];
	int uzrast;
	int br_igracaka;
	
	int balans;
	struct dete *levi,*desni;
};
void novo_stablo(struct dete *,struct dete **,int );
void ispis(struct dete *);
struct dete *formiraj();
int dodaj(struct dete **,char [],int ,int );
int dubina (struct dete *);
void d_rotacija(struct dete **);
void l_rotacija(struct dete **);


int dodaj(struct dete **p,char ime[],int uzrast,int br_igracaka)
{
	struct dete *t;
	int inkrement,rezultat=0;
	t=*p;
	if(t==NULL)
	{
		t=(struct dete *)malloc(sizeof(struct dete));
		if (t==NULL)
		{
			printf("Greska\n");
			exit(0);
		}
		
		strcpy(t->ime,ime);
		t->uzrast=uzrast;
		t->br_igracaka=br_igracaka;
		
		t->levi=t->desni=NULL;
		t->balans=0;
		rezultat=1;
	}
	else
	{
		if(t->uzrast<=uzrast)
		{
			if(strcmp(t->ime,ime)<=0)
				inkrement=dodaj(&t->desni,ime,uzrast,br_igracaka);
			else
				inkrement=-dodaj(&t->levi,ime,uzrast,br_igracaka);
		}
		else
		{	if(strcmp(t->ime,ime)<=0)
				inkrement=dodaj(&t->desni,ime,uzrast,br_igracaka);
			else
				inkrement=-dodaj(&t->levi,ime,uzrast,br_igracaka);		
		}
		
		t->balans+=inkrement;
		
		if(t->balans!=0 && inkrement !=0)
		{
			if(t->balans<-1) 
			{
				if(t->levi->balans<0) d_rotacija(&t);
				else
				{
					l_rotacija(&(t->levi));
					d_rotacija(&t);
				}
			}
			else 
				if(t->balans>1) 
				{
					if(t->desni->balans>0) l_rotacija(&t);
					else
					{
						d_rotacija(&(t->desni));
						l_rotacija(&t);
					}
				}
				else rezultat=1;
		}
	}
	*p=t;
	return rezultat;
}
struct dete *formiraj()
{
	struct dete *koren=NULL;
	int i,n;
	char ime[10];
	int uzrast,br;
	printf("Unesi broj dece\n");
	scanf("%d",&n);
	for(i=0;i<n;i++)
	{
		printf("Unesi ime %d deteta:\n",i+1);
		scanf("%s",ime);
		printf("Unesi njegov uzrast\n");
		scanf("%d",&uzrast);
		printf("Unesi njegov broj_poklona\n");
		scanf("%d",&br);
		
		dodaj(&koren,ime,uzrast,br);
	}
	return koren;
}
void ispis(struct dete *p)
{
	if(p==NULL) return;
	ispis(p->desni);
	printf("\n%s\t%d\t%d",p->ime,p->uzrast,p->br_igracaka);
	ispis(p->levi);
}

void novo_stablo(struct dete *p,struct dete **q,int mes)
{
	if(p==NULL)	return;
	if(p->uzrast+12<mes)
		dodaj(q,p->ime,p->uzrast,p->br_igracaka);	
		
	novo_stablo(p->levi,q,mes);
	novo_stablo(p->desni,q,mes);
}

			
			


void l_rotacija(struct dete **p)
{
	struct dete *poml,*pomd;
	
	poml=*p;
	pomd=poml->desni;
	poml->desni=pomd->levi;
	pomd->levi=poml;
	*p=pomd;
	
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}
void d_rotacija(struct dete **p)
{
	struct dete *poml,*pomd;
	
	pomd=*p;
	poml=pomd->levi;
	pomd->levi=poml->desni;
	poml->desni=pomd;
	*p=poml;
	
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}
int dubina (struct dete *p)
{
	if(p==NULL) return 0;
	int a,b;
	a=1+dubina(p->levi);
	b=1+dubina(p->desni);
	if (a>b) return a;
	else return b;
}

main()
{
	struct dete *p,*q=NULL;
	p=formiraj();
	ispis(p);
	int x,m;
	printf("\nUnesi granicu za godine\n");
	scanf("%d",&x);
	m=x*12;
	novo_stablo(p,&q,m);
	ispis(q);
	
}
