#include<stdio.h>
#include<stdlib.h>
#include<string.h>

typedef struct drvo {
	char ime[20];
	int uzrast;
	int broj_igracaka;
	int balans;
	struct drvo *levi,*desni;
}DRVO;

#define novi(x) x=(DRVO *)malloc(sizeof(DRVO))

int dubina(DRVO *p){
	int dl=0,dd=0;
	if(p){
		if(p->levi) dl=dubina(p->levi);
		if(p->desni) dd=dubina(p->desni);
		if(dl>dd) return ++dl;
		else return ++dd;
		
	}
	return 0;
	
}

void lrotacija(DRVO **t){
	DRVO * poml,*pomd;
	poml=(*t);
	pomd=poml->desni;
	poml->desni=pomd->levi;
	pomd->levi=poml;
	(*t)=pomd;
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
	
	
}
void drotacija(DRVO **t){
	DRVO * poml,*pomd;
	pomd=(*t);
	poml=pomd->levi;
	pomd->levi=poml->desni;
	poml->desni=pomd;
	(*t)=poml;
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
	
	
}


int dodaj(DRVO **p,char * ime, int uzrast,int broj_igr){
	DRVO *t=*p;
	int inkrement,rezultat=1;
	if(t==NULL){
		novi(t);
		if(t==NULL){
			printf("Greska pri alokaciji memorije\n");
			exit(0);
		}
		strcpy(t->ime,ime);
		t->uzrast=uzrast;
		t->broj_igracaka=broj_igr;
		t->levi=t->desni=NULL;
		t->balans=0;
		rezultat=1;
	}
	else{
		if((uzrast>t->uzrast))
		inkrement=dodaj(&(t->desni),ime,uzrast,broj_igr);
		else if((uzrast==t->uzrast) && (strcmp(ime,t->ime)>0))
		inkrement=dodaj(&(t->desni),ime,uzrast,broj_igr);
		else if((strcmp(ime,t->ime)>0)&&(uzrast==t->uzrast))
		inkrement=dodaj(&(t->desni),ime,uzrast,broj_igr);
		else
		inkrement=-dodaj(&(t->levi),ime,uzrast,broj_igr);
		
		t->balans+=inkrement;
		if(inkrement!=0 && t->balans!=0){
			if(t->balans<-1){
				if(t->levi->balans<0) drotacija((&t));
				else{
					lrotacija(&(t->levi));
					drotacija(&(t));
				}
			}
		
		if(t->balans>1){
			if(t->desni->balans>0) lrotacija(&(t));
			else{
				drotacija(&(t->desni));
				lrotacija(&(t));
			}
			
		}
	else rezultat=1;
			
			
		}
	
	}
	(*p)=t;
	return rezultat;
	
}

	
	
DRVO * form(){
	DRVO *p;
	p=NULL;
	int n;
	printf("Unesite broj dece\n");
	scanf("%d",&n);
	getchar();
	int i;
	char ime[20];
	int uzrast;
	int broj_igr;
	for(i=0;i<n;i++)
	{
		scanf("%s",ime);
		scanf("%d",&uzrast);
		scanf("%d",&broj_igr);
		dodaj(&p,ime,uzrast,broj_igr);
	}
	
	return p;
}

void brisi(DRVO *p,DRVO **q,int godina){
	if(p){
		if(p->levi) brisi(p->levi,q,godina);
		if(p->desni) brisi(p->desni,q,godina);
		
		if(((p->uzrast)/12)<(godina))
		dodaj(q,p->ime,p->uzrast,p->broj_igracaka);
	}

}
void stampa(DRVO *p,int k,int m){
	if(p){

		if((p->balans==k) && (p->uzrast==m)){
		printf("Dete %s se nalazi na nivou %d i ima %d meseci!\n",p->ime,k,m);
		if(p->levi) stampa(p->levi,k,m);
		if(p->desni) stampa(p->desni,k,m);
	}
		else{
		if(p->levi) stampa(p->levi,k,m);
		if(p->desni) stampa(p->desni,k,m);
		}
	}

}
void ispis(DRVO *p){
	if(p){
		if(p->desni) ispis(p->desni);
		printf("%s\t%d\t%d\n",p->ime,p->uzrast,p->broj_igracaka);
		if(p->levi) ispis(p->levi);
		
	}
	}
main(){
	DRVO *p,*q;
	q=NULL;
	p=form();
	ispis(p);
	printf("---------------\n");
	int godina;
	printf("Unesite broj godina:\n");
	scanf("%d",&godina);
	brisi(p,&q,godina);
	ispis(q);
	printf("----------------\n");
	int k,m;
	printf("Unesite nivo:\n");
	scanf("%d",&k);
	printf("Unesite broj meseci:\n");
	scanf("%d",&m);
	stampa(q,k,m);
	
}
