# include <stdio.h>
# include <stdlib.h>
# include <string.h>

struct dete
{
char ime[20];
int uzrast;
int bri;
int balans;
struct dete *levi,*desni;
};

# define novi(x) x=(struct dete *)malloc(sizeof(struct dete))


int dubina(struct dete *p)
{
	if(p==NULL) return 0;
	int a=1+dubina(p->levi);
	int b=1+dubina(p->desni);
	if(a>b) return a;
	else return b;
}


void l_rotacija(struct dete **p)
{
	struct dete *poml,*pomd;
	poml=*p;
	pomd=poml->desni;
	poml->desni=pomd->levi;
	pomd->levi=poml;
	*p=pomd;
	
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}

void d_rotacija(struct dete **p)
{
	struct dete *poml,*pomd;
	pomd=*p;
	poml=pomd->levi;
	pomd->levi=poml->desni;
	poml->desni=pomd;
	*p=poml;
	
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);	
}

int dodaj(struct dete **p,char ime[],int uzrast,int bri)
{
	struct dete *t;
	int inkrement,rezultat;
	t=*p;
	if(t==NULL)
	{
		novi(t);
		if(t==NULL)
		{
			printf("Greska\n");
			exit(0);
		}
		strcpy(t->ime,ime);
		t->uzrast=uzrast;
		t->bri=bri;
		t->balans=0;
		t->levi=t->desni=NULL;
		rezultat=1;
	}
	else
	{
		if(t->uzrast!=uzrast)
		{
			if(t->uzrast<uzrast)
			inkrement=dodaj(t->desni,ime,uzrast,bri);
			else
			inkrement=-dodaj(t->levi,ime,uzrast,bri);
		}
		else
		{
			if(strcmp(t->ime,ime)==0)
			inkrement=dodaj(t->desni,ime,uzrast,bri);
			else
			inkrement=-dodaj(t->levi,ime,uzrast,bri);
		}
		t->balans+=inkrement;
		if(inkrement!=0 && t->balans!=0)
		{
			if(t->balans<-1)
			{
				if(t->levi->balans<0) d_rotacija(&t);
				else
				{
					l_rotacija(&(t->levi));
					d_rotacija(&t);
				}
			}
			else if(t->balans>1)
			{
				if(t->desni->balans>0) l_rotacija(&t);
				else
				{
					d_rotacija(&(t->desni));
					l_rotacija(&t);
				}
			}
			else rezultat=1;
		}	
	}
	*p=t;
	return rezultat;	
}


struct dete *form()
{
	struct dete *koren;
	koren=NULL;
	char s[20];
	int i,n,u,br;
	printf("Unesi n: ");
	scanf("%d",&n);
	for(i=0;i<n;i++)
	{
	printf("%d. dete\n",i+1);
	printf("Unesi ime deteta: ");
	scanf("%s",&s);
	printf("Unesi uzrast: ");
	scanf("%d",&u);
	printf("Unesi broj: ");
	scanf("%d",&br);

	dodaj(&koren,s,u,br);
	}
return koren;
}

void ispis(struct dete *p)
{
	if(p=NULL) return;
	ispis(p->desni);
	printf("\n %s \t %d \t %d \n",p->ime,p->uzrast,p->bri);
	ispis(p->levi);
}

void novo_stablo(struct dete **q,struct dete *p,int x)
{
	if(p->uzrast<x) dodaj(&q,p->ime,p->uzrast,p->bri);
	novo_stablo(&q,p->levi,x);
	novo_stablo(&q,p->desni,x);
}

main()
{
	struct dete *p;
	struct dete *q;
	int x;
	p=NULL;
	p=form();
	ispis(p);
	printf("Unesi granicu x: ");
	scanf("%d",&x);
	x=x*12;
	q=NULL;
	novo_stablo(&q,p,x);
	ispis(q);	
}
