#include<stdio.h>
#include<stdlib.h>
#include<string.h>

enum {CRNA,CRVENA};

struct drvo {
	char ime[30];
	int uzrast;
	int broj_igracaka;
	int boja;
	struct drvo *roditelj,*levi,*desni;
};

#define novi(x) x=(struct drvo*)malloc(sizeof(struct drvo))


void lrotacija(struct drvo **t)
{
	struct drvo *x,*y;
	x=*t;
	y=x->desni;
	x->desni=y->levi;
	
	if(y->levi)
		y->levi->roditelj=x;
	y->roditelj=x->roditelj;
	
	if (x->roditelj)
		if(x==x->roditelj->levi)
			x->roditelj->levi=y;
		else
			x->roditelj->desni=y;
	
	y->levi=x;
	x->roditelj=y;
	*t=y;
}

void drotacija(struct drvo **t)
{
	struct drvo *x,*y;
	y=*t;
	x=y->levi;
	y->levi=x->desni;
	
	if(x->desni)
		x->desni->roditelj=y;
	x->roditelj=y->roditelj;
	
	if (y->roditelj)
		if(y==y->roditelj->levi)
			y->roditelj->levi=x;
		else
			y->roditelj->desni=x;
			
	x->desni=y;
	y->roditelj=x;
	*t=x;
}

void bojefix(struct drvo **p,struct drvo *z)
{
	struct drvo *y,*t;
	
	while ((z->roditelj) && (z->roditelj->boja==CRVENA))
	{
		if(z==z->roditelj->roditelj->levi)
		{
			y=z->roditelj->roditelj->desni;
			if ((y) && (y->boja==CRVENA))
			{
				z->roditelj->boja=CRNA;
				y->boja=CRNA;
				z->roditelj->roditelj->boja=CRVENA;
				z=z->roditelj->roditelj;
			}
			else
			{
				if(z==z->roditelj->desni)
				{
					z=z->roditelj;
					lrotacija(&z);
					if (!z->roditelj)
						*p=z;
					z=z->levi;
				}
				z->roditelj->boja=CRNA;
				z->roditelj->roditelj->boja=CRVENA;
				t=z->roditelj->roditelj;
				drotacija(&t);
				if(!t->roditelj)
					*p=t;
			}
		}
		else
		{
			y=z->roditelj->roditelj->levi;
			if ((y) && (y->boja==CRVENA))
			{
				z->roditelj->boja=CRNA;
				y->boja=CRNA;
				z->roditelj->roditelj->boja=CRVENA;
				z=z->roditelj->roditelj;
			}
			else
			{
				if(z==z->roditelj->levi)
				{
					z=z->roditelj;
					drotacija(&z);
					if (!z->roditelj);
						*p=z;
					z=z->desni;
				}
				z->roditelj->boja=CRNA;
				z->roditelj->roditelj->boja=CRVENA;
				t=z->roditelj->roditelj;
				lrotacija(&t);
				if(!t->roditelj)
					*p=t;
			}
		}
	}
	(*p)->boja=CRNA;
}

void dodaj(struct drvo **p,struct drvo *z) 
{
	struct drvo *x,*y;
	x=*p;
	y=NULL;
	
	while(x)
	{
		y=x;
		if(z->uzrast < x->uzrast)
			x=x->levi;
		else
			x=x->desni;		
	}
	z->roditelj=y;
	if(!y)
		*p=z;
	else
	{
		if (z->uzrast < y->uzrast)
			y->levi=z;
		else
			y->desni=z;
	}
	bojefix(p,z);
}

struct drvo *form () {
	struct drvo *koren,*cvor;
	int i,n;
	koren=NULL;
	char s[30];
	char c;
	
	printf("UNesi broj dece: ");
	scanf("%d",&n);
	scanf("%c",&c);
	
	for(i=0;i<n;i++)
	{
		novi(cvor);
		
		printf("UNesi ime deteta:");
		gets(s);
		strcpy(cvor->ime,s);
		printf("Unesi uzrast: ");
		scanf("%d",&cvor->uzrast);
		printf("Unesi broj igracaka: ");
		scanf("%d",&cvor->broj_igracaka);
		scanf("%c",&c);
		
		cvor->boja=CRVENA;
		cvor->levi=cvor->desni=NULL;
		dodaj(&koren,cvor);
	}
	return koren;
}

void ispis(struct drvo *p)
{
	if(p)
	{
		ispis(p->desni);
		printf("%s,%d,%d-",p->ime,p->uzrast,p->broj_igracaka);
		if (p->boja==CRVENA)
			printf("CRVENA\n");
		else
			printf("CRNA\n");
		ispis(p->levi);
	}
}

void brisi(struct drvo **p,struct drvo *q,int x)
{
	struct drvo *pom;
	
	if (q)
		if ( ((12 + q->uzrast) / 12) < x) 
		{
			novi(pom);
			strcpy(pom->ime,q->ime);
			pom->uzrast=q->uzrast;
			pom->broj_igracaka=q->broj_igracaka;
			pom->boja=CRVENA;
			pom->roditelj=NULL;
			pom->levi=pom->desni=NULL;
			dodaj(p,pom);
			brisi(p,q->levi,x);
			brisi(p,q->desni,x);
		}
		else
		{
			brisi(p,q->levi,x);
			brisi(p,q->desni,x);
		}
		else
			return;
}
			

main () {
	struct drvo *koren,*nov;
	koren=NULL;
	nov=NULL;
	int x;
	
	koren=form();
	ispis(koren);
	printf("Unesi broj x: ");
	scanf("%d",&x);
	brisi(&nov,koren,x);
	if (nov)
		ispis(nov);
	

	
	
}

		
